#!/usr/bin/env python
# -*- coding: utf-8 -*-

import sys;
sys.dont_write_bytecode = True;

import os;
import signal;
import base64;
from threading import Thread, Timer
import math;
import time;
import datetime;
import json;
import io;
from time import sleep;
from threading import Thread;
from Crypto.Cipher import AES;
from Crypto.Hash import SHA256;
from Crypto import Random
import hashlib;
import hmac;
import traceback;
import binascii

import websocket;
import curve25519;
import pyqrcode;
from utilities import *;
from whatsapp_binary_reader import whatsappReadBinary;
from whatsapp_defines import WAWebMessageInfo, WAMetrics;
from whatsapp_binary_writer import whatsappWriteBinary

import codecs

# WHATSAPP_WEB_VERSION="0,4,2081"
WHATSAPP_WEB_VERSION="2,2119,6"
# import importlib

# reload(sys);
# sys.setdefaultencoding("utf-8");

i=0
chats=[]
contacts=[]
messages=[]




def HmacSha256(key, sign):
    return hmac.new(key, sign, hashlib.sha256).digest();

def HKDF(key, length, appInfo=""):						# implements RFC 5869, some parts from https://github.com/MirkoDziadzka/pyhkdf
    key = HmacSha256(b'\0'*32, key);
    keyStream = "".encode()
    keyBlock = "".encode();
    blockIndex = 1;
    while len(keyStream) < length:
        keyBlock = hmac.new(key, msg=keyBlock+appInfo.encode()+chr(blockIndex).encode(), digestmod=hashlib.sha256).digest();
        blockIndex += 1;
        keyStream += keyBlock;
    return keyStream[:length];

def AESPad(s):
    bs = AES.block_size;
    return s + (bs - len(s) % bs) * chr(bs - len(s) % bs);

def to_bytes(n, length, endianess='big'):
    h = '%x' % n
    s = ('0'*(len(h) % 2) + h).zfill(length*2).decode('hex')
    return s if endianess == 'big' else s[::-1]

def AESUnpad(s):
    return s[:-ord(s[len(s)-1:])];

def AESEncrypt(key, plaintext):							# like "AESPad"/"AESUnpad" from https://stackoverflow.com/a/21928790
    plaintext = AESPad(plaintext);
    iv = os.urandom(AES.block_size);
    cipher = AES.new(key, AES.MODE_CBC, iv);
    return iv + cipher.encrypt(plaintext);

def WhatsAppEncrypt(encKey, macKey, plaintext):
    enc = AESEncrypt(encKey, plaintext)
    return HmacSha256(macKey, enc) + enc;				# this may need padding to 64 byte boundary

def AESDecrypt(key, ciphertext):						# from https://stackoverflow.com/a/20868265
    iv = ciphertext[:AES.block_size];
    cipher = AES.new(key, AES.MODE_CBC, iv);
    plaintext = cipher.decrypt(ciphertext[AES.block_size:]);
    return AESUnpad(plaintext);



class WhatsAppWebClient:
    websocketIsOpened = False;
    onOpenCallback = None;
    onMessageCallback = None;
    onCloseCallback = None;
    activeWs = None;
    messageSentCount = 0;
    websocketThread = None;
    messageQueue = {};																# maps message tags (provided by WhatsApp) to more information (description and callback)
    loginInfo = {
        "clientId": None,
        "serverRef": None,
        "privateKey": None,
        "publicKey": None,
        "key": {
            "encKey": None,
            "macKey": None
        }
    };
    connInfo = {
        "clientToken": None,
        "serverToken": None,
        "browserToken": None,
        "secret": None,
        "sharedSecret": None,
        "me": None
    };

    def __init__(self, onOpenCallback, onMessageCallback, onCloseCallback):
        self.onOpenCallback = onOpenCallback;
        self.onMessageCallback = onMessageCallback;
        self.onCloseCallback = onCloseCallback;
        websocket.enableTrace(True);
        self.connect();



    def onOpen(self, ws):
        try:
            self.websocketIsOpened = True;
            if self.onOpenCallback is not None and "func" in self.onOpenCallback:
                self.onOpenCallback["func"](self.onOpenCallback);
            eprint("WhatsApp backend Websocket opened.");
        except:
            eprint(traceback.format_exc());

    def onError(self, ws, error):
        pass
        # eprint(error);

    def onClose(self, ws):
        self.websocketIsOpened = False;
        if self.onCloseCallback is not None and "func" in self.onCloseCallback:
            self.onCloseCallback["func"](self.onCloseCallback);
        eprint("WhatsApp backend Websocket closed.");

    def onMessage(self, ws, message):
        try:
            if isinstance(message, str):
                message_split = message.split(",", 1);
            else:
                message_split = message.split(b',', 1);

            print("GETTING HERE")

            messageTag = message_split[0];
            try:
                message_content = message_split[1];
            except Exception:
                print("ERROR")
            print("GETTING HERE AS WELL")
            
            if messageTag in self.messageQueue:											# when the server responds to a client's message
                # Handle responses to requests
                pend = self.messageQueue[messageTag];
                if pend["desc"] == "_status":
                    if message_content[0] == 'Pong' and message_content[1] == True:
                        pend["callback"]({"Connected": True,"user":self.connInfo["me"],"pushname":self.connInfo["pushname"]})
                elif pend["desc"] == "_restoresession":
                    eprint("")  # TODO implement Challenge Solving
                elif pend["desc"] == "_login":
                    self.handle_login_response(message_content, pend)
            else:
                print("GETTING HERE AS WELL (3)")
                try:
                    json_obj = json.loads(message_content);								# try reading as json
                    print("GETTING HERE AS WELL (4)")
                except ValueError:
                    print("GETTING HERE AS WELL (5)")
                    self.handle_whatsapp_response(message_content)
                else:
                    print("GETTING HERE AS WELL ()")
                    self.handle_json_message(json_obj)
                    
        except Exception as e:
            pass
            # print(e)
            # pass
            # p
            # eprint(traceback.format_exc());
    
    def handle_login_response(self, message_content, pend):
        self.loginInfo["serverRef"] = json.loads(message_content)["ref"];
        self.loginInfo["privateKey"] = curve25519.Private();
        self.loginInfo["publicKey"] = self.loginInfo["privateKey"].get_public();
        qrCodeContents = self.loginInfo["serverRef"] + "," + base64.b64encode(self.loginInfo["publicKey"].serialize()).decode() + "," + self.loginInfo["clientId"];
        svgBuffer = io.BytesIO(); # from https://github.com/mnooner256/pyqrcode/issues/39#issuecomment-207621532
        pyqrcode.create(qrCodeContents, error='L').svg(svgBuffer, scale=6, background="rgba(0,0,0,0.0)", module_color="#122E31", quiet_zone=0);
        if "callback" in pend and pend["callback"] is not None and "func" in pend["callback"] and \
             pend["callback"]["func"] is not None and "tag" in pend["callback"] and pend["callback"]["tag"] is not None:
            base64_img_val = base64.b64encode(svgBuffer.getvalue()).decode()
            pend["callback"]["func"]({ "type": "generated_qr_code", "image": "data:image/svg+xml;base64," + base64_img_val,
             "content": qrCodeContents }, pend["callback"]);

    def handle_whatsapp_response(self, message_content):
        # Handle encrypted message
        print("MESSAGE CONTENT")
        print(message_content)
        if message_content != "":
            hmacValidation = HmacSha256(self.loginInfo["key"]["macKey"], message_content[32:]);
            if hmacValidation != message_content[:32]:
                raise ValueError("Hmac mismatch");
            
            decrypted_proto_message = AESDecrypt(self.loginInfo["key"]["encKey"], message_content[32:]);
            print("PROTO_MESSAGE")
            print(decrypted_proto_message)

            global i
            i+=1


            #############################
            # THIS IS WHERE MESSAGES COME IN!!!
            #############################
            try:
                print("USING BINARY READER")

                processedData = whatsappReadBinary(decrypted_proto_message, True);
                print("PROCESSEDDATA")
                print(processedData)
                metadata=processedData[:2]
                response_data = processedData[2]
                # print(i)
                # print(metadata)
                for i in range(10):
                    print("GETTING HERE")

                print("\nproccesed data")
                # print(processedData)
                print()
                message = processedData[2]
                # print(processedData[2])
                global chats
                global contacts
                global messages

                add_location = metadata[1].get("add", None)
                response_type = metadata[1].get("type", None)
                if metadata[1].get("add", None) == "before":
                    # messages = 


                    # handle normal message
                    with open("data/data" +str(i) +".json", "w") as f:
                        f.write(str(processedData[2]))
                elif response_type == "contacts":
                    with open("data/contacts.json", "w") as f:
                        f.write(str(processedData[2]))
                elif response_type == "chat":
                    with open("data/chats.json", "w") as f:
                        f.write(str(processedData[2]))

                messageType = "binary";

            except Exception as e:
                print(e)
                processedData = { "traceback": traceback.format_exc().splitlines() };
                print(processedData)

                messageType = "error";
            finally:
                self.onMessageCallback["func"](processedData, self.onMessageCallback, { "message_type": messageType });


    def handle_json_message(self, json_obj):
        self.onMessageCallback["func"](json_obj, self.onMessageCallback, { "message_type": "json" });
        if isinstance(json_obj, list) and len(json_obj) > 0:					# check if the result is an array
            eprint("RECEIVED JSON OBJECT WITH CONNECTION INFO FROM WHATSAPP ")
            eprint(json.dumps(json_obj));
            if json_obj[0] == "Conn":
                Timer(25, lambda: self.activeWs.send('?,,')).start() # Keepalive Request
                self.connInfo["clientToken"] = json_obj[1]["clientToken"];
                self.connInfo["serverToken"] = json_obj[1]["serverToken"];
                self.connInfo["browserToken"] = json_obj[1]["browserToken"];
                self.connInfo["me"] = json_obj[1]["wid"];
                self.connInfo["secret"] = base64.b64decode(json_obj[1]["secret"]);
                self.connInfo["sharedSecret"] = self.loginInfo["privateKey"].get_shared_key(curve25519.Public(self.connInfo["secret"][:32]), lambda a: a);

                # print(self.connInfo["sharedSecret"])
                sse = self.connInfo["sharedSecretExpanded"] = HKDF(self.connInfo["sharedSecret"], 80);
                hmacValidation = HmacSha256(sse[32:64], self.connInfo["secret"][:32] + self.connInfo["secret"][64:]);
                if hmacValidation != self.connInfo["secret"][32:64]:
                    raise ValueError("Hmac mismatch");

                keysEncrypted = sse[64:] + self.connInfo["secret"][64:];
                keysDecrypted = AESDecrypt(sse[:32], keysEncrypted);
                self.loginInfo["key"]["encKey"] = keysDecrypted[:32];
                self.loginInfo["key"]["macKey"] = keysDecrypted[32:64];

                eprint("set connection info: client, server and browser token; secret, shared secret, enc key, mac key");
                eprint("logged in as " + json_obj[1]["pushname"]  + " (" + json_obj[1]["wid"] + ")");
            elif json_obj[0] == "Stream":
                pass;
            elif json_obj[0] == "Props":
                pass;

    def connect(self):
        self.activeWs = websocket.WebSocketApp("wss://web.whatsapp.com/ws",
                                               on_message = lambda ws, message: self.onMessage(ws, message),
                                               on_error = lambda ws, error: self.onError(ws, error),
                                               on_open = lambda ws: self.onOpen(ws),
                                               on_close = lambda ws: self.onClose(ws),
                                               header = { "Origin: https://web.whatsapp.com" });
        
        self.websocketThread = Thread(target = self.activeWs.run_forever);
        self.websocketThread.daemon = True;
        self.websocketThread.start();

    def generateQRCode(self, callback=None):
        self.loginInfo["clientId"] = base64.b64encode(os.urandom(16)).decode();
        messageTag = str(getTimestamp());
        self.messageQueue[messageTag] = { "desc": "_login", "callback": callback };
        message = messageTag + ',["admin","init",['+ WHATSAPP_WEB_VERSION + '],["Chromium at ' + datetime.datetime.now().isoformat() + '","Chromium"],"' + self.loginInfo["clientId"]  + '",true]';
        self.activeWs.send(message);

    def restoreSession(self, callback=None):
        messageTag = str(getTimestamp())
        message = messageTag + ',["admin","init",['+ WHATSAPP_WEB_VERSION + '],["Chromium at ' + datetime.now().isoformat() + '","Chromium"],"' + self.loginInfo["clientId"] + '",true]'
        self.activeWs.send(message)

        messageTag = str(getTimestamp())
        self.messageQueue[messageTag] = {"desc": "_restoresession"}
        message = messageTag + ',["admin","login","' + self.connInfo["clientToken"] + '", "' + self.connInfo[
            "serverToken"] + '", "' + self.loginInfo["clientId"] + '", "takeover"]'

        self.activeWs.send(message)
        
    def getLoginInfo(self, callback):
        callback["func"]({ "type": "login_info", "data": self.loginInfo }, callback);
    
    def getConnectionInfo(self, callback):
        callback["func"]({ "type": "connection_info", "data": self.connInfo }, callback);
    
    def sendTextMessage(self, number, text):
        messageId = "3EB0"+binascii.hexlify(Random.get_random_bytes(8)).upper()
        messageTag = str(getTimestamp())
        messageParams = {"key": {"fromMe": True, "remoteJid": number + "@s.whatsapp.net", "id": messageId},"messageTimestamp": getTimestamp(), "status": 1, "message": {"conversation": text}}
        msgData = ["action", {"type": "relay", "epoch": str(self.messageSentCount)},[["message", None, WAWebMessageInfo.encode(messageParams)]]]
        encryptedMessage = WhatsAppEncrypt(self.loginInfo["key"]["encKey"], self.loginInfo["key"]["macKey"],whatsappWriteBinary(msgData))
        payload = bytearray(messageId) + bytearray(",") + bytearray(to_bytes(WAMetrics.MESSAGE, 1)) + bytearray([0x80]) + encryptedMessage
        self.messageSentCount = self.messageSentCount + 1
        self.messageQueue[messageId] = {"desc": "__sending"}
        self.activeWs.send(payload, websocket.ABNF.OPCODE_BINARY)
        
    def status(self, callback=None):
        if self.activeWs is not None:
            messageTag = str(getTimestamp())
            self.messageQueue[messageTag] = {"desc": "_status", "callback": callback}
            message = messageTag + ',["admin", "test"]'
            self.activeWs.send(message)

    def disconnect(self):
        self.activeWs.send('goodbye,,["admin","Conn","disconnect"]');		# WhatsApp server closes connection automatically when client wants to disconnect
        #time.sleep(0.5);
        #self.activeWs.close();
